/************************************************************************************/
/*  Program name CAPFNDEXT_CONC_PROG_SERIAL.sql                                     */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 12 JAN, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_CONC_PROG_SERIAL';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_CONC_PROG_SERIAL.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		FCPS.*
	FROM
		FND_CONCURRENT_PROGRAM_SERIAL	FCPS,
		FND_CONCURRENT_PROGRAMS			FCP,
		FND_CONCURRENT_PROGRAMS_TL		FCPT
	WHERE	FCP.Application_ID						=	FCPT.Application_ID
	AND		FCP.Concurrent_Program_ID				=	FCPT.Concurrent_Program_ID
	AND		FCPT.Language							=	'US'
	AND		SUBSTR(FCPT.User_Concurrent_Program_Name,1,4)	=	p_NGO
	AND		FCPT.Concurrent_Program_ID				=	FCPS.Running_Concurrent_Program_ID
	ORDER BY
		FCPT.Application_ID,
		FCPT.User_Concurrent_Program_Name;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.RUNNING_APPLICATION_ID||CHR(9)||
				C1.RUNNING_CONCURRENT_PROGRAM_ID||CHR(9)||
				C1.TO_RUN_APPLICATION_ID||CHR(9)||
				C1.TO_RUN_CONCURRENT_PROGRAM_ID||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.UPDATE_SECURITY_GROUP_ID||CHR(9)||
				C1.RUNNING_TYPE||CHR(9)||
				C1.TO_RUN_TYPE||CHR(9)||
				C1.INCOMPATIBILITY_TYPE||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO_Name||': No Concurrent Program Serial for this NGO';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
